package com.bpermissions.gui.util;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;

import de.bananaco.bpermissions.api.Group;
import de.bananaco.bpermissions.api.User;
import de.bananaco.bpermissions.api.World;
import de.bananaco.bpermissions.api.util.Permission;

public class JSONWorld extends World {

	public String jsonString;
	
	public JSONWorld(String world, String jsonString) {
		super(world);
		this.jsonString = jsonString;
	}

	@SuppressWarnings("unchecked")
	@Override
	public boolean load() {
		try {
		JSONParser parser = new JSONParser();
		JSONObject data = (JSONObject) parser.parse(jsonString);
		
		JSONObject users = (JSONObject) data.get("users");
		JSONObject groups = (JSONObject) data.get("groups");
		
		// TODO handle metadata
		for(Object user : users.keySet()) {
			String u = user.toString();
			JSONObject d = (JSONObject) users.get(user);
			JSONArray gr = (JSONArray) d.get("groups");
			JSONArray pr = (JSONArray) d.get("permissions");
			JSONObject meta = (JSONObject) d.get("meta");
			// Here's the groups and permissions defined easily
			List<String> grS = new ArrayList<String>(gr);
			List<String> prS = new ArrayList<String>(pr);
			// Load the perms
			Set<Permission> perms = Permission.loadFromString(prS);
			// Create the object
			User us = new User(u, grS, perms, getName(), this);
			us.getMeta().putAll(meta);
			add(us);
		}
		for(Object group : groups.keySet()) {
			String g = group.toString();
			JSONObject d = (JSONObject) groups.get(group);
			JSONArray gr = (JSONArray) d.get("groups");
			JSONArray pr = (JSONArray) d.get("permissions");
			JSONObject meta = (JSONObject) d.get("meta");
			// Here's the groups and permissions defined easily
			List<String> grS = new ArrayList<String>(gr);
			List<String> prS = new ArrayList<String>(pr);
			// Load the perms
			Set<Permission> perms = Permission.loadFromString(prS);
			// Create the object
			Group grp = new Group(g, grS, perms, getName(), this);
			grp.getMeta().putAll(meta);
			add(grp);
		}
		
		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}

	@Override
	public boolean save() {

		return false;
	}

	@Override
	public String getDefaultGroup() {
		return "default";
	}

	@Override
	public boolean setupPlayer(String player) {
		// Don't need to do anything here
		return false;
	}

}
