package com.bpermissions.gui.util;

import java.util.ArrayList;
import java.util.List;

import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

import de.bananaco.bpermissions.api.World;
import de.bananaco.bpermissions.api.WorldManager;
import de.bananaco.bpermissions.api.util.Calculable;
import de.bananaco.bpermissions.api.util.CalculableType;

public class JSONWorldManager {
	
	private String jsonString = "";
	private WorldManager wm = WorldManager.getInstance();
	
	public JSONWorldManager(String jsonString) {
		this.jsonString = jsonString;
	}
	
	public void decode() throws ParseException {
		if(jsonString == null || jsonString.equals("")) {
			System.err.println("BAD JSON");
			return;
		}
		
		JSONParser parser = new JSONParser();
		JSONObject obj = (JSONObject) parser.parse(jsonString);
		List<JSONWorld> worlds = new ArrayList<JSONWorld>();
		for(Object world : obj.keySet()) {
			String w = world.toString();
			JSONObject wd = (JSONObject) obj.get(world);
			JSONWorld jsw = new JSONWorld(w, wd.toJSONString());
			worlds.add(jsw);
		}
		// Now load them all
		for(JSONWorld world : worlds) {
			world.load();
		}
		// Now transfer them all to their appropriate normal place
		for(JSONWorld world : worlds) {
			World w = wm.getWorld(world.getName());
			for(Calculable c : world.getAll(CalculableType.USER)) {
				w.add(c);
			}
			for(Calculable c : world.getAll(CalculableType.GROUP)) {
				w.add(c);
			}
		}
		// And save all
		wm.saveAll();
		System.out.println("[bPermissionsWebGUI] Data updated.");
	}

}
